"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (tweetUrl, filePath) {
  var tweetId = (0, _twitterUrlParser2.default)(tweetUrl).id;
  var tweetSelector = ".tweet[data-tweet-id=\"" + tweetId + "\"]";
  var sensitiveMediaSelector = tweetSelector + " button.js-display-this-media";
  var nightmare = new _nightmare2.default();

  return Promise.resolve().then(function () {
    return nightmare.viewport(2000, 2000);
  }).then(function () {
    return nightmare.goto(tweetUrl);
  }).then(function () {
    return nightmare.wait(tweetSelector);
  }).then(function () {
    return nightmare.exists(sensitiveMediaSelector);
  }).then(function (isSensitive) {
    return isSensitive && nightmare.click(sensitiveMediaSelector).wait(1000);
  }).then(function () {
    return nightmare.evaluate(function (tweetSelector) {
      var tweet = document.querySelector(tweetSelector);
      tweet.style.borderRadius = "0px"; // Ensure that the tweet completely fills the screenshot rectangle.

      var rectangle = tweet.getBoundingClientRect();
      return {
        x: Math.round(rectangle.left),
        y: Math.round(rectangle.top),
        width: Math.round(rectangle.width),
        height: Math.round(rectangle.height)
      };
    }, tweetSelector);
  }).then(function (rectangle) {
    return nightmare.screenshot(filePath, rectangle);
  }).then(function () {
    return nightmare.end();
  });
};

var _nightmare = require("nightmare");

var _nightmare2 = _interopRequireDefault(_nightmare);

var _twitterUrlParser = require("twitter-url-parser");

var _twitterUrlParser2 = _interopRequireDefault(_twitterUrlParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }